﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DockManager;

namespace XamDockManager_DirtyTab
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel()
            {
                View1 = new View() { Content = "View 1 Content", Header = "Document 1" },
                View2 = new View() { Content = "View 2 Content", Header = "Document 2" },
                View3 = new View() { Content = "View 3 Content", Header = "Document 3" }
            };
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            ((sender as Button).DataContext as View).IsDirty =false;
        }
    }

    public class ViewModel
    {
        public View View1 { get; set; }
        public View View2 { get; set; }
        public View View3 { get; set; }
    }
    public class View : INotifyPropertyChanged
    {
        #region Header (INotifyPropertyChanged Property)
        private string _header;

        public string Header
        {
            get { return _header; }
            set
            {
                _header = value;
                RaisePropertyChanged("Header");
            }
        }
        #endregion
        
        #region IsDirty (INotifyPropertyChanged Property)
        private bool _isDirty;

        public bool IsDirty
        {
            get { return _isDirty; }
            set
            {
                _isDirty = value;
                RaisePropertyChanged("IsDirty");
            }
        }
        #endregion
        
        #region Content (INotifyPropertyChanged Property)
        private string _content;

        public string Content
        {
            get { return _content; }
            set
            {
                if (!string.IsNullOrEmpty(value) && !string.IsNullOrEmpty(_content) && value!=_content)
                {
                    _isDirty = true;
                    RaisePropertyChanged("IsDirty");
                }

                _content = value;
                RaisePropertyChanged("Content");
            }
        }
        #endregion
        
        #region INotifyPropertyChanged values

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion

        public View()
        {
            this.IsDirty = false;
        }
    }
}
